<template>
  <div class="announce-upload">
    <div class="textbox">
      <div>ยืนยันสิทธิ์การสมัคร</div>
      <span>อัพโหลด หลักฐานการโอนเงิน และใบ ปพ.1 หรือ ปพ.7</span> <br>
      <span class="text-left">
        โอนเข้าบัญชีออมทรัพย์ ธนาคารไทยพาณิชย์ จำกัด (มหาชน) <br>
        ชื่อบัญชี คณะไอทีลาดกระบัง กระทำการแทนโดย <br>
        นายนพพร โชติกำธร เเละ นางสาวพิจิตรา สุวรรณศรี <br>
        เลขที่บัญชี 088 – 259833 – 4 <br><br>

        วิธีโอน ให้โอนเงินจำนวน 500 บาท และใส่เศษสตางค์ตามเลขท้ายรหัส <br>
        ==== ตัวอย่างเช่น ==== <br>
        ผู้สมัครลำดับที่ 3 โอนเงินจำนวน 500.03 บาท <br>
        ผู้สมัครลำดับที่ 25 โอนเงินจำนวน 500.25 บาท <br><br>
      </span>
      <span style="color:#ef4647">*เศษสตางค์สำคัญมากเพราะใช้ในการตรวจสอบ ให้น้อง ๆ ตรวจทานให้แน่ใจว่าใส่จำนวนเงินถูกต้องและ <br>ให้น้อง ๆ โอนผ่านทางเคาน์เตอร์ธนาคาร หรือโอนที่ตู้ ATM เท่านั้นครับ</span>
    </div>
    <hr>
    <form>
      <div class="form-group">
        <label>อัพโหลดใบ หลักฐานการโอนเงิน</label>
        <div class="image-preview pt-4 pb-4 pl-2 pr-2" v-if="imageData.slip != null">
          <img class="preview w-100" :src="imageData.slip">
        </div>
        <input type="file" name="slip" id="slip" class="form-control" v-validate=" 'required|size:5000'" accept="image/*, application/pdf" @change="onFileChange">
        <span v-show="errors.has('slip')" class="color-red" style="font-size: 13px">{{ errors.first('slip') }}</span>
      </div>
      <div class="form-group">
        <label>อัพโหลดใบ ปพ.1 หรือ ปพ.7</label>
        <div class="image-preview pt-4 pb-4 pl-2 pr-2" v-if="imageData.cert != null">
          <img class="preview w-100" :src="imageData.cert">
        </div>
        <input type="file" name="cert" id="cert" class="form-control" v-validate=" 'required|size:5000'" accept="image/*, application/pdf" @change="onFileChange">
        <span v-show="errors.has('cert')" class="color-red" style="font-size: 13px">{{ errors.first('cert') }}</span>
      </div>
      <div class="form-group">
        <label>รายละเอียดเพิ่มเติม (หากมี)</label>
        <textarea v-model="submit.desc" name="upload_desc" id="desc" class="form-control"></textarea>
      </div>
      <hr>
      <div class="row m-0 upload-desc">
        <div class="col-12 topic">
          * หมายเหตุ
        </div>
        <div class="col-12">
          - ให้น้อง ๆ ถ่ายรูป หรือแสกนหลักฐานมาก็ได้ แต่ขอให้ภาพชัดเจนนะครับ
        </div>
        <div class="col-12">
          - หลักฐานการโอนเงิน เช่น สำเนาการโอน, สลิป เป็นต้น
        </div>
        <div class="col-12">
          - หากน้องมีปัญหาในการขอเอกสารกับทางโรงเรียนให้ติดต่อพี่ ๆ มาทาง <a href="https://www.facebook.com/itcampKMITL/" target="_blank">ITCamp Page</a> ได้เลย
        </div>
        <div class="col-12">
          - หากน้องไม่ส่งหลักฐานจะถือว่าสละสิทธิ์ในการเข้าร่วมค่ายไอทีแคมป์ครั้งที่ 14
        </div>
        <div class="col-12">
          - สามารถโอนเงินและแนบเอกสารการโอน อย่างได้ถึงวันที่ 20 พฤษภาคม 2561 เวลา 23:59 น.
        </div>
      </div>
      <div class="row m-0">
        <div class="row col-12 col-sm announce-button mb-2 danger">
          <div class="button-border" @click="confirmReject()">
            <div class="button-core">
              สละสิทธิ์
            </div>
          </div>
        </div>
        <div class="row col-12 col-sm announce-button mb-2 success">
          <div class="button-border" @click="confirmSubmit()">
            <div class="button-core">
              ยืนยันสิทธิ์
            </div>
          </div>
        </div>
      </div>
    </form>
    <br>
    <hr>
    <br>
    <div class="row">
      <div class="col-12 text-right" style="font-size: 15px">
        หากสงสัย สามารถสอบถามเพิ่มเติมได้ที่
        <a href="fb.com/groups/ITCampSociety">ITCampSociety</a><br>
        หรือโทร 094-205-5394 (พี่มิ้ว)<br>
        หรือโทร 0956144176 (พี่ต้อม)
      </div>
    </div>
  </div>
</template>

<script>
import swal from 'sweetalert2';
import router from '../../../router';
import { mapActions, mapGetters } from 'vuex';
import { Validator } from 'vee-validate';

const messages = {
  en: {
    messages: {
      required: () => 'ต้องการข้อมูล',
      size: (name, val) => 'ขนาดไฟล์ต้องไม่เกิน ' + val + ' KB'
    }
  }
};
Validator.localize(messages);

export default {
  name: 'Announce_Upload',
  data() {
    return {
      imageData: {
        slip: null,
        cert: null
      },
      submit: {
        slip: null,
        cert: null,
        desc: null
      }
    };
  },
  methods: {
    ...mapGetters(['getUserInfo']),
    ...mapActions(['submitConfirm', 'rejectConfirm']),

    onFileChange(e) {
      var files = e.target.files || e.dataTransfer.files;
      var name = e.srcElement.id;
      if (!files.length) return;
      this.submit[name] = files[0];
      this.createImage(e, name);
    },

    createImage(event, name) {
      var input = event.target;
      if (input.files && input.files[0]) {
        var reader = new FileReader();
        reader.onload = (e) => {
          this.imageData[name] = e.target.result;
        };
        reader.readAsDataURL(input.files[0]);
      }
    },

    confirmSubmit() {
      this.$validator.validateAll().then((result) => {
        if (!result) return false;
        swal({
          type: 'info',
          title: 'ยืนยันการสมัคร',
          text: 'น้องต้องการส่งเอกสารยืนยันสิทธิ์การสมัคร หรือไม่?',
          showCancelButton: true,
          confirmButtonColor: '#25aae1',
          cancelButtonText: 'ไม่, กลับไปแก้ไข',
          confirmButtonText: 'ใช่, ยืนยันสิทธิ์การสมัคร'
        }).then((result) => {
          if (result.value) {
            this.submitConfirm(this.submit)
              .then((response) => {
                swal({
                  type: 'success',
                  title: 'ยืนยันเสร็จสิ้น',
                  html: 'น้องได้ยืนยันสิทธิ์การสมัคร เสร็จเรียบร้อยแล้ว <br>ยินดีต้อนรับเข้าสู่บ้านแคมป์ IT CAMP ค่ะ'
                }).then(() => {
                  router.push({ name: 'Announce_Summary' });
                });
              })
              .catch((err) => {
                swal({
                  type: 'error',
                  title: 'ไม่สามารถยืนยันสิทธิ์ได้',
                  text: 'กรุณาติดต่อพี่ผู้ได้แล'
                });
              });
          }
        });
      });
    },

    confirmReject() {
      swal({
        type: 'warning',
        title: 'สละสิทธิ์',
        html:
          'หากน้องสละสิทธิ์ ทางพี่ๆจะเรียกเพื่อนจากลำดับรองขึ้นมาแทน และน้องจะไม่มีสิทธิ์เข้าร่วมค่ายไอทีแคมป์ครั้งที่ 14 นี้ ไม่ว่ากรณีใด ๆก็ตาม',
        showCancelButton: true,
        confirmButtonColor: '#cc0000',
        cancelButtonText: 'ไม่, ย้อนกลับ',
        confirmButtonText: 'ใช่, สละสิทธิ์'
      }).then((result) => {
        if (result.value) {
          this.rejectConfirm()
            .then((response) => {
              if (response.data && response.status === 200) {
                swal({
                  type: 'success',
                  title: 'สละสิทธิ์',
                  html: 'น้องได้ทำการยืนยัน การสละสิทธิ์แล้ว'
                }).then(() => {
                  router.push({ name: 'Index' });
                });
              }
            })
            .catch((err) => {
              swal({
                type: 'error',
                title: 'ไม่สามารถสละสิทธิ์ได้',
                text: 'กรุณาติดต่อพี่ผู้ได้แลและแจ้งข้อความนี้: ' + err.response
              });
            });
        }
      });
    }
  },

  created() {}
};
</script>

<style>

</style>
